def vertical_selector(type):
    """ Choose vertical for url based on entity type """
    return {
        "College": "colleges",
        "School": "k12",
        "SchoolDistrict": "k12"
    }.get(type, "places-to-live")

def route_selector(type):
    """ Choose route for url based on entity type """
    return {
        "SchoolDistrict": "d/",
        "Neighborhood": "n/",
        "County": "c/",
        "ZipCode": "z/",
        "State": "s/"
    }.get(type, "")

def build(tld, type, frag):
    """ Generate full entity url """
    protocol = "https" if tld == "com" else "http"
    return str(
        "%s://www.niche.%s/%s/%s%s/" % (
            protocol, 
            tld, 
            vertical_selector(type), 
            route_selector(type),
            frag
        )
    )